/*****************************************************************
Classe: 	Camada
Descricao: 	Definicao de um camada
Arquivo: 	Camada.cpp
Autor: 		Cyro Albuquerque Neto
Criacao: 	01/09/2008
Revisao: 	28/08/2008
******************************************************************/

#include "camada.h"

void Camada::SetCelLim(IntPos vIni, IntPos vFim) 
{
	celLim.ini = vIni;
	celLim.fim = vFim;
}

//--------------------------------------------------------------------
void Camada::AtualizaTamCel()
{ 
	tamCelula = (posicao.fim-posicao.ini)/nCelula; 
}

//--------------------------------------------------------------------
ListaCamada::~ListaCamada()
{
	for (IntPos i=1; i<lista.size(); i++) delete lista[i];
	lista.clear();
}

//--------------------------------------------------------------------
void ListaCamada::NovaCamada(double fim, IntPos div)
{
	lista.push_back(new Camada(fim,div));
}

//--------------------------------------------------------------------
double ListaCamada::NCelula()
{
	double numero = 0.0;
	for (IntPos i=0; i<lista.size(); ++i) 
		numero += lista.at(i)->NCelula();
	return numero;
}

//--------------------------------------------------------------------
void ListaCamada::GeraCamadas()
{
	//Determina ponto inicial de cada camada em cada sentido
	lista[0]->SetPosicaoIni(0.0);
	for (IntPos i=1; i<lista.size(); i++) 
		lista[i]->SetPosicaoIni(lista[i-1]->Posicao().fim);

	//Atualiza tamanho das celulas
	for (IntPos i=0; i<lista.size(); i++) lista[i]->AtualizaTamCel();
	
	//Celula inicial e final das camadas
	lista[0]->SetCelLim(0,lista[0]->NCelula()-1);
	for (IntPos i=1; i<lista.size(); i++)
		lista[i]->SetCelLim(lista[i-1]->CelLim().fim+1,
				lista[i-1]->CelLim().fim+lista[i]->NCelula());
}

//--------------------------------------------------------------------
void ListaCamada::PlotaCamada()
{
	std::cout << std::fixed << std::setprecision(4);
	std::cout << std::setw(8) << "Camada"; 
	std::cout << std::setw(8) << "NumVol" << std::setw(8) << "PtoIni" 
		 << std::setw(8) << "PtoFim" << std::setw(8) << "VolIni" 
		 << std::setw(8) << "VolFim" << std::setw(8) << "dVol" 
		 << std::endl;
	for (IntPos i=0; i<lista.size(); i++) {
		std::cout << std::setw(8) << i 
		 	 << std::setw(8) << lista[i]->NCelula()
			 << std::setw(8) << lista[i]->Posicao().ini
			 << std::setw(8) << lista[i]->Posicao().fim
			 << std::setw(8) << lista[i]->CelLim().ini
			 << std::setw(8) << lista[i]->CelLim().fim
			 << std::setw(8) << lista[i]->TamCelula()
			 << std::endl;
	}
}
