/*****************************************************************
Classe: 	Camada, ListaCamada
Descricao: 	Definicao de uma camada e lista de camada
Arquivo: 	Camada.h
Autor: 		Cyro Albuquerque Neto
Criacao: 	01/09/2008
Revisao: 	28/08/2008
******************************************************************/

#ifndef CAMADAH
#define CAMADAH

#include <vector>
#include <iostream>
#include <iomanip>

#include "definicao.h"

class Camada {
	IntPos nCelula;
	Limite<double> posicao;
	Limite<IntPos> celLim;
	double tamCelula;	
public:
	//Construtor
	Camada() {};
	Camada(double valPosFim, IntPos valNCel) : nCelula(valNCel) 
		{ posicao.fim = valPosFim; }
	//Numero de celulas na camada
	IntPos NCelula() const { return nCelula; }
	//Posicao inicial da camada
	void SetPosicaoIni(double valor) { posicao.ini=valor; }
	//Retorna posicao da camada
	Limite<double> Posicao() const { return posicao; }
	//Numero da celula inicial e final
	void SetCelLim(IntPos vIni, IntPos vFim);
	Limite<IntPos> CelLim() const { return celLim; }
	//Tamanho de cada celula
	double TamCelula() const { return tamCelula; }
	void AtualizaTamCel();
};

//--------------------------------------------------------------------
class ListaCamada {
	std::vector<Camada*> lista;
public:
	ListaCamada() {};
	~ListaCamada();
	void NovaCamada(double fim, IntPos div);

	/** 
	* \brief Calcula numero de celulas em todas camadas
	* \return numero de celulas 
	*/
	double NCelula();
	IntPos Tam() const { return lista.size(); }
	//Retorna valor do elemento i
	Camada* operator() (IntPos val) const { return lista[val]; }
	Camada* Em(IntPos val) { return lista[val]; }
	//Ponto final
	double PontoFinal() const { return lista.back()->Posicao().fim; }
	void GeraCamadas();
	void PlotaCamada();
};

#endif
