#ifndef LISTAFACEH
#define LISTAFACEH

#include <cmath>
#include <iostream>
#include <vector>

#include "definicao.h"
#include "face.h"
#include "ponto.h"
#include "listacelula.h"

using namespace std;

/*****************************************************//**
* \class	ListaFace 
* \brief	Lista de Faces
* \author	Cyro Albuquerque Neto
* \date		Criacao: 21/12/2008
* \date		Revisao: 10/10/2008
*********************************************************/
//class Face;
//class Camada;

class ListaFace {

public:
	/**
	 * Construtor
	 */
	ListaFace();
	//ListaFace(IntPos dimensao, SistCoord sistCoordenada,
	//		    vector<ListaCamada>& listaCamada, 
	//		    Matriz<PropTerm*>& propTermica);

	/**
	* Destrutor
	* \brief Apaga lista de faces
	*/
	~ListaFace();

	Face* Em(IntPos valor) { return faces.at(valor); }
	vector<Face*>* Vet() { return &faces; }

	void GeraListaFace(IntPos nDim, SistCoord sistCoord,
					   ListaCelula& lCel, Ponto<double>);

private:
	/// Lista de Faces 
	vector<Face*> faces;
	Ponto<double> tamanhoExterno;
	SistCoord sistCoord;
	//IntPos nDim;
	//ListaCelula *lCel;

	double CalcNumFace(); 

	/**
	* Verifica quais faces devem ser criadas para uma celula.
	* \param iF numero da face
	* \param iC numero da celula
	* \param par vetor com endereco das fronteiras 
	*
	* Chama funcao para criar as faces posteriores a celula,
	* interior ou exterior. Se celula estiver no limite inferior,
	* chama tambem funcao para criar face anterior.
	*/
	void CriaFace(IntPos nDim, ListaCelula& lCel,
		                IntPos& iF, VetInt iC);

	void AtualizaVizinhoInt(IntPos,VetInt,Direcao,ListaCelula&);
	void AtualizaVizinhoExt(IntPos,VetInt,Sentido,ListaCelula&);
	void CriaFaceInt(IntPos&,VetInt,Direcao,ListaCelula&);
	void CriaFaceExt(IntPos&,VetInt,Sentido,Direcao,ListaCelula&);
};

#endif
